/* $Id: ObitTableMFRowDef.h 123 2009-09-04 11:26:14Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
/*  Define the basic components of the ObitTableRow structure       */
/*  This is intended to be included in a class structure definition   */
/**
 * \file ObitTableMFRowDef.h
 * ObitTableMFRow structure members for derived classes.
 */
#include "ObitTableRowDef.h"  /* Parent class definitions */
/** Plane number */
ofloat  plane;
/** Peak Ipol */
ofloat  Peak;
/** Integrated Ipol flux */
ofloat  IFlux;
/** X offset of center */
ofloat  DeltaX;
/** Y offset of center */
ofloat  DeltaY;
/** Fitted major axis size */
ofloat  MajorAx;
/** Fitted minor axis size */
ofloat  MinorAx;
/** Fitted PA */
ofloat  PosAngle;
/** Integrated Q flux density */
ofloat  QFlux;
/** Integrated U flux density */
ofloat  UFlux;
/** Integrated Y flux density */
ofloat  VFlux;
/** rror in Peak Ipol */
ofloat  errPeak;
/** rror in Integrated Ipol flux */
ofloat  errIFlux;
/** Error in X offset of center */
ofloat  errDeltaX;
/** Error in Y offset of center */
ofloat  errDeltaY;
/** Error in Fitted major axis size */
ofloat  errMajorAx;
/** Error in Fitted minor axis size */
ofloat  errMinorAx;
/** Error in Fitted PA */
ofloat  errPosAngle;
/** Error in Integrated Q flux density */
ofloat  errQFlux;
/** Error in Integrated U flux density */
ofloat  errUFlux;
/** Error in Integrated Y flux density */
ofloat  errVFlux;
/** Model type 1 = Gaussian */
ofloat  TypeMod;
/** Deconvolved best major axis */
ofloat  D0Major;
/** Deconvolved best minor axis */
ofloat  D0Minor;
/** Deconvolved best PA */
ofloat  D0PosAngle;
/** Deconvolved least major axis */
ofloat  DmMajor;
/** econvolved least minor axis */
ofloat  DmMinor;
/** Deconvolved least PA */
ofloat  DmPosAngle;
/** Deconvolved most major axis */
ofloat  DpMajor;
/** Deconvolved most minor axis */
ofloat  DpMinor;
/** Deconvolved most PA */
ofloat  DpPosAngle;
/** RMS of Ipol residual */
ofloat  ResRMS;
/** Peak in Ipol residual */
ofloat  ResPeak;
/** Integrated Ipol in residual */
ofloat  ResFlux;
/** Center x position in pixels */
ofloat  PixelCenterX;
/** Center y position in pixels */
ofloat  PixelCenterY;
/** Fitted major axis in pixels */
ofloat  PixelMajorAxis;
/** Fitted minor axis in pixels */
ofloat  PixelMinorAxis;
/** Fitted PA(?) */
ofloat  PixelPosAngle;
/** status 0=normal, 1=modified, -1=flagged */
olong  status;
