/* $Id: ObitTableCT.c 128 2009-09-23 14:48:29Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableCT.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableCT.c
 * ObitTableCT class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableCT";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableCTRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCTRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableCTClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCTClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableCTRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableCTRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableCTInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableCTClear (gpointer in);

/** Private: update table specific info */
static void ObitTableCTUpdate (ObitTableCT *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableCTDumpKey (ObitTableCT *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableCTClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableCTRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCTRow* newObitTableCTRow (ObitTableCT *table)
{
  ObitTableCTRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCTRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCTRow));

  /* initialize values */
  out->name = g_strdup("TableCT Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableCTRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->wobXY = dRow + table->wobXYOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableCTRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableCTRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCTRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableCTRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCT* newObitTableCT (gchar* name)
{
  ObitTableCT* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCTClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCT));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableCTInit((gpointer)out);

 return out;
} /* end newObitTableCT */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableCTGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCTClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitCTGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numBand The number of Bands(?).
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableCT* newObitTableCTValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numBand,
		     ObitErr *err)
{
  ObitTableCT* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS CT";
  gchar *routine = "newObitTableCTValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCTClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS CT");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableCT */
      if (ObitTableCTIsA(testTab)) { /* it is an ObitTableCT */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableCTConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS CT");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableCTIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableCTConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numBand = MAX (0, numBand);
  out->revision = 2;
  strncpy (out->obscode, "AA000", MAXKEYCHARTABLECT );
  strncpy (out->RefDate, "YYYYMMDD", MAXKEYCHARTABLECT );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 11 + out->numBand*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("UT1-UTC");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("IAT-UTC");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("A1-UTC");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("UT1 TYPE");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("WOBXY ");
    desc->FieldUnit[colNo] = g_strdup("MILLIARC");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("WOB TYPE");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DPSI");
  desc->FieldUnit[colNo] = g_strdup("RAD");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DDPSI");
  desc->FieldUnit[colNo] = g_strdup("RAD/SEC");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DEPS");
  desc->FieldUnit[colNo] = g_strdup("RAD");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DDEPS ");
  desc->FieldUnit[colNo] = g_strdup("RAD/SEC");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableCTDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableCTOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableCTClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableCTValue */

/**
 * Convert an ObitTable to an ObitTableCT.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableCT* ObitTableCTConvert (ObitTable* in)
{
  ObitTableCT *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableCT(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableCTConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableCT* ObitTableCTCopy (ObitTableCT *in, ObitTableCT *out, ObitErr *err)
{
  gchar *routine = "ObitTableCTCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCTClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableCT*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLECT );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLECT );
  out->numStkd = in->numStkd;
  out->stk1 = in->stk1;
  out->numBand = in->numBand;
  out->numChan = in->numChan;
  out->refFreq = in->refFreq;
  out->chanBW = in->chanBW;
  out->refPixl = in->refPixl;
  strncpy (out->CSrvr, in->CSrvr, MAXKEYCHARTABLECT );
  strncpy (out->CVersn, in->CVersn, MAXKEYCHARTABLECT );
  strncpy (out->AVersn, in->AVersn, MAXKEYCHARTABLECT );
  strncpy (out->IVersn, in->IVersn, MAXKEYCHARTABLECT );
  strncpy (out->EVersn, in->EVersn, MAXKEYCHARTABLECT );
  out->accelgrv = in->accelgrv;
  out->Eflat = in->Eflat;
  out->earthrad = in->earthrad;
  out->mmsems = in->mmsems;
  out->ephepoc = in->ephepoc;
  out->tidelag = in->tidelag;
  out->gauss = in->gauss;
  out->gmmoon = in->gmmoon;
  out->gmsun = in->gmsun;
  out->loveH = in->loveH;
  out->loveL = in->loveL;
  out->preData = in->preData;
  out->relData = in->relData;
  out->tidalut1 = in->tidalut1;
  out->tsecau = in->tsecau;
  out->UGrvCn = in->UGrvCn;
  out->vlight = in->vlight;
  /* Update class specific info */
  ObitTableCTUpdate (out, err);
    
  return out;
} /* end ObitTableCTCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCTOpen (ObitTableCT *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableCTOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCTClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableCTUpdate (in, err);
   
   return retCode;
} /* end ObitTableCTOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iCTRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCTReadRow  (ObitTableCT *in, olong iCTRow, ObitTableCTRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCTReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CT Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iCTRow */
  retCode = ObitTableRead ((ObitTable*)in, iCTRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->ut1utc = dRow[in->ut1utcOff];
  row->iatutc = dRow[in->iatutcOff];
  row->a1utc = dRow[in->a1utcOff];
  row->ut1Type = cRow[in->ut1TypeOff];
  row->wobType = cRow[in->wobTypeOff];
  row->dpsi = dRow[in->dpsiOff];
  row->ddpsi = dRow[in->ddpsiOff];
  row->deps = dRow[in->depsOff];
  row->ddeps = dRow[in->ddepsOff];
  row->wobXY = dRow + in->wobXYOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableCTReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableCTSetRow  (ObitTableCT *in, ObitTableCTRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "CT Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->wobXY = dRow + in->wobXYOff;

} /*  end ObitTableCTSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableCTSetRow  
 * \param in       Table to read
 * \param iCTRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCTWriteRow  (ObitTableCT *in, olong iCTRow, ObitTableCTRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCTWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CT Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  dRow[in->ut1utcOff] = row->ut1utc;
  dRow[in->iatutcOff] = row->iatutc;
  dRow[in->a1utcOff] = row->a1utc;
  cRow[in->ut1TypeOff] = row->ut1Type;
  cRow[in->wobTypeOff] = row->wobType;
  dRow[in->dpsiOff] = row->dpsi;
  dRow[in->ddpsiOff] = row->ddpsi;
  dRow[in->depsOff] = row->deps;
  dRow[in->ddepsOff] = row->ddeps;
  if (in->wobXYCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->wobXYCol]; i++) 
      dRow[in->wobXYOff+i] = row->wobXY[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iCTRow */
  retCode = ObitTableWrite ((ObitTable*)in, iCTRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableCTWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCTClose (ObitTableCT *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableCTClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableCTDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableCTClose */

/*---------------Private functions--------------------------*/
/*----------------  TableCT Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCTRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCTRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->wobXY = NULL;

} /* end ObitTableCTRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCTRow* cast to an Obit*.
 */
void ObitTableCTRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCTRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCTRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCTRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableCTRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCTRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCTRowClassInfoDefFn (gpointer inClass)
{
  ObitTableCTRowClassInfo *theClass = (ObitTableCTRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCTRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCTRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCTRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableCTRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableCTRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableCTRowInit;

} /* end ObitTableCTRowClassDefFn */

/*------------------  TableCT  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCTInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCT *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableCTInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCT* cast to an Obit*.
 */
void ObitTableCTClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCT *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCTClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCTClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableCTClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCTClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCTClassInfoDefFn (gpointer inClass)
{
  ObitTableCTClassInfo *theClass = (ObitTableCTClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCTClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCTClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCTGetClass;
  theClass->newObit       = (newObitFP)newObitTableCT;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableCTCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableCTClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableCTInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableCTConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableCTOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableCTClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableCTReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableCTWriteRow;

} /* end ObitTableCTClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCTUpdate (ObitTableCT *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 2; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);
   /* obscode */
  strncpy (in->obscode, "AA000", MAXKEYCHARTABLECT); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* RefDate */
  strncpy (in->RefDate, "YYYYMMDD", MAXKEYCHARTABLECT); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numStkd */
  if (!ObitInfoListGet(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->numStkd, err)) return;
   /* stk1 */
  if (!ObitInfoListGet(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk1, err)) return;
   /* numBand */
  if (!ObitInfoListGet(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand, err)) return;
   /* numChan */
  if (!ObitInfoListGet(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->numChan, err)) return;
   /* refFreq */
  if (!ObitInfoListGet(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refFreq = InfoReal.dbl;
  if (type==OBIT_float)  in->refFreq = InfoReal.flt;
   /* chanBW */
  if (!ObitInfoListGet(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->chanBW = InfoReal.dbl;
  if (type==OBIT_float)  in->chanBW = InfoReal.flt;
   /* refPixl */
  if (!ObitInfoListGet(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refPixl = InfoReal.dbl;
  if (type==OBIT_float)  in->refPixl = InfoReal.flt;
   /* CSrvr */
  if (!ObitInfoListGet(in->myDesc->info, "C_SRVR", &type, dim, 
		       (gpointer)&in->CSrvr, err)) return;
   /* CVersn */
  if (!ObitInfoListGet(in->myDesc->info, "C_VERSN", &type, dim, 
		       (gpointer)&in->CVersn, err)) return;
   /* AVersn */
  if (!ObitInfoListGet(in->myDesc->info, "A_VERSN", &type, dim, 
		       (gpointer)&in->AVersn, err)) return;
   /* IVersn */
  if (!ObitInfoListGet(in->myDesc->info, "I_VERSN", &type, dim, 
		       (gpointer)&in->IVersn, err)) return;
   /* EVersn */
  if (!ObitInfoListGet(in->myDesc->info, "E_VERSN", &type, dim, 
		       (gpointer)&in->EVersn, err)) return;
   /* accelgrv */
  if (!ObitInfoListGet(in->myDesc->info, "ACCELGRV", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->accelgrv = InfoReal.dbl;
  if (type==OBIT_float)  in->accelgrv = InfoReal.flt;
   /* Eflat */
  if (!ObitInfoListGet(in->myDesc->info, "E-FLAT", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->Eflat = InfoReal.dbl;
  if (type==OBIT_float)  in->Eflat = InfoReal.flt;
   /* earthrad */
  if (!ObitInfoListGet(in->myDesc->info, "EARTHRAD", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->earthrad = InfoReal.dbl;
  if (type==OBIT_float)  in->earthrad = InfoReal.flt;
   /* mmsems */
  if (!ObitInfoListGet(in->myDesc->info, "MMSEMS", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->mmsems = InfoReal.dbl;
  if (type==OBIT_float)  in->mmsems = InfoReal.flt;
   /* ephepoc */
  if (!ObitInfoListGet(in->myDesc->info, "EPHEPOC", &type, dim, 
		       (gpointer)&in->ephepoc, err)) return;
   /* tidelag */
  if (!ObitInfoListGet(in->myDesc->info, "TIDELAG", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->tidelag = InfoReal.dbl;
  if (type==OBIT_float)  in->tidelag = InfoReal.flt;
   /* gauss */
  if (!ObitInfoListGet(in->myDesc->info, "GAUSS", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->gauss = InfoReal.dbl;
  if (type==OBIT_float)  in->gauss = InfoReal.flt;
   /* gmmoon */
  if (!ObitInfoListGet(in->myDesc->info, "GMMOON", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->gmmoon = InfoReal.dbl;
  if (type==OBIT_float)  in->gmmoon = InfoReal.flt;
   /* gmsun */
  if (!ObitInfoListGet(in->myDesc->info, "GMSUN", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->gmsun = InfoReal.dbl;
  if (type==OBIT_float)  in->gmsun = InfoReal.flt;
   /* loveH */
  if (!ObitInfoListGet(in->myDesc->info, "LOVE_H", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->loveH = InfoReal.dbl;
  if (type==OBIT_float)  in->loveH = InfoReal.flt;
   /* loveL */
  if (!ObitInfoListGet(in->myDesc->info, "LOVE_L", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->loveL = InfoReal.dbl;
  if (type==OBIT_float)  in->loveL = InfoReal.flt;
   /* preData */
  if (!ObitInfoListGet(in->myDesc->info, "PRE_DATA", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->preData = InfoReal.dbl;
  if (type==OBIT_float)  in->preData = InfoReal.flt;
   /* relData */
  if (!ObitInfoListGet(in->myDesc->info, "REL_DATA", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->relData = InfoReal.dbl;
  if (type==OBIT_float)  in->relData = InfoReal.flt;
   /* tidalut1 */
  if (!ObitInfoListGet(in->myDesc->info, "TIDALUT1", &type, dim, 
		       (gpointer)&in->tidalut1, err)) return;
   /* tsecau */
  if (!ObitInfoListGet(in->myDesc->info, "TSECAU", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->tsecau = InfoReal.dbl;
  if (type==OBIT_float)  in->tsecau = InfoReal.flt;
   /* UGrvCn */
  if (!ObitInfoListGet(in->myDesc->info, "U-GRV-CN", &type, dim, 
		       (gpointer)&in->UGrvCn, err)) return;
   /* vlight */
  if (!ObitInfoListGet(in->myDesc->info, "VLIGHT", &type, dim, 
		       (gpointer)&in->vlight, err)) return;

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->ut1utcOff = -1;
  in->ut1utcCol = -1;
  in->iatutcOff = -1;
  in->iatutcCol = -1;
  in->a1utcOff = -1;
  in->a1utcCol = -1;
  in->ut1TypeOff = -1;
  in->ut1TypeCol = -1;
  in->wobXYOff = -1;
  in->wobXYCol = -1;
  in->wobTypeOff = -1;
  in->wobTypeCol = -1;
  in->dpsiOff = -1;
  in->dpsiCol = -1;
  in->ddpsiOff = -1;
  in->ddpsiCol = -1;
  in->depsOff = -1;
  in->depsCol = -1;
  in->ddepsOff = -1;
  in->ddepsCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "UT1-UTC", 7)) {
	 in->ut1utcOff = desc->offset[i];
 	 in->ut1utcCol = i;
      }
      if (!strncmp (desc->FieldName[i], "IAT-UTC", 7)) {
	 in->iatutcOff = desc->offset[i];
 	 in->iatutcCol = i;
      }
      if (!strncmp (desc->FieldName[i], "A1-UTC", 6)) {
	 in->a1utcOff = desc->offset[i];
 	 in->a1utcCol = i;
      }
      if (!strncmp (desc->FieldName[i], "UT1 TYPE", 8)) {
	 in->ut1TypeOff = desc->offset[i];
 	 in->ut1TypeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "WOBXY ", 6)) {
	 in->wobXYOff = desc->offset[i];
 	 in->wobXYCol = i;
      }
      if (!strncmp (desc->FieldName[i], "WOB TYPE", 8)) {
	 in->wobTypeOff = desc->offset[i];
 	 in->wobTypeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DPSI", 4)) {
	 in->dpsiOff = desc->offset[i];
 	 in->dpsiCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DDPSI", 5)) {
	 in->ddpsiOff = desc->offset[i];
 	 in->ddpsiCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DEPS", 4)) {
	 in->depsOff = desc->offset[i];
 	 in->depsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DDEPS ", 6)) {
	 in->ddepsOff = desc->offset[i];
 	 in->ddepsCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableCTUpdate: Could not find column Time");
  Obit_return_if_fail((in->ut1utcOff > -1), err,
       "ObitTableCTUpdate: Could not find column ut1utc");
  Obit_return_if_fail((in->iatutcOff > -1), err,
       "ObitTableCTUpdate: Could not find column iatutc");
  Obit_return_if_fail((in->a1utcOff > -1), err,
       "ObitTableCTUpdate: Could not find column a1utc");
  Obit_return_if_fail((in->ut1TypeOff > -1), err,
       "ObitTableCTUpdate: Could not find column ut1Type");
  Obit_return_if_fail((in->wobXYOff > -1), err,
       "ObitTableCTUpdate: Could not find column wobXY");
  Obit_return_if_fail((in->wobTypeOff > -1), err,
       "ObitTableCTUpdate: Could not find column wobType");
  Obit_return_if_fail((in->dpsiOff > -1), err,
       "ObitTableCTUpdate: Could not find column dpsi");
  Obit_return_if_fail((in->ddpsiOff > -1), err,
       "ObitTableCTUpdate: Could not find column ddpsi");
  Obit_return_if_fail((in->depsOff > -1), err,
       "ObitTableCTUpdate: Could not find column deps");
} /* end ObitTableCTUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCTDumpKey (ObitTableCT *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numStkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->numStkd);
  /* stk1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk1);
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->numChan);
  /* refFreq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->refFreq);
  /* chanBW */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chanBW);
  /* refPixl */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->refPixl);
  /* CSrvr */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "C_SRVR", type, dim, 
		  (gpointer)&in->CSrvr);
  /* CVersn */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "C_VERSN", type, dim, 
		  (gpointer)&in->CVersn);
  /* AVersn */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "A_VERSN", type, dim, 
		  (gpointer)&in->AVersn);
  /* IVersn */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "I_VERSN", type, dim, 
		  (gpointer)&in->IVersn);
  /* EVersn */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLECT;
  ObitInfoListAlwaysPut(info, "E_VERSN", type, dim, 
		  (gpointer)&in->EVersn);
  /* accelgrv */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "ACCELGRV", type, dim, 
		  (gpointer)&in->accelgrv);
  /* Eflat */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "E-FLAT", type, dim, 
		  (gpointer)&in->Eflat);
  /* earthrad */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "EARTHRAD", type, dim, 
		  (gpointer)&in->earthrad);
  /* mmsems */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MMSEMS", type, dim, 
		  (gpointer)&in->mmsems);
  /* ephepoc */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "EPHEPOC", type, dim, 
		  (gpointer)&in->ephepoc);
  /* tidelag */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TIDELAG", type, dim, 
		  (gpointer)&in->tidelag);
  /* gauss */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "GAUSS", type, dim, 
		  (gpointer)&in->gauss);
  /* gmmoon */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "GMMOON", type, dim, 
		  (gpointer)&in->gmmoon);
  /* gmsun */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "GMSUN", type, dim, 
		  (gpointer)&in->gmsun);
  /* loveH */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "LOVE_H", type, dim, 
		  (gpointer)&in->loveH);
  /* loveL */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "LOVE_L", type, dim, 
		  (gpointer)&in->loveL);
  /* preData */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "PRE_DATA", type, dim, 
		  (gpointer)&in->preData);
  /* relData */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REL_DATA", type, dim, 
		  (gpointer)&in->relData);
  /* tidalut1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TIDALUT1", type, dim, 
		  (gpointer)&in->tidalut1);
  /* tsecau */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TSECAU", type, dim, 
		  (gpointer)&in->tsecau);
  /* UGrvCn */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "U-GRV-CN", type, dim, 
		  (gpointer)&in->UGrvCn);
  /* vlight */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "VLIGHT", type, dim, 
		  (gpointer)&in->vlight);
   
} /* end ObitTableCTDumpKey */
