/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_GAIN_CURVE.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_GAIN_CURVE.c
 * ObitTableIDI_GAIN_CURVE class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_GAIN_CURVE";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_GAIN_CURVERow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_GAIN_CURVERowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_GAIN_CURVEClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_GAIN_CURVEClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_GAIN_CURVERowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_GAIN_CURVERowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_GAIN_CURVEInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_GAIN_CURVEClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_GAIN_CURVEUpdate (ObitTableIDI_GAIN_CURVE *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_GAIN_CURVEDumpKey (ObitTableIDI_GAIN_CURVE *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_GAIN_CURVEClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_GAIN_CURVERowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_GAIN_CURVERow* newObitTableIDI_GAIN_CURVERow (ObitTableIDI_GAIN_CURVE *table)
{
  ObitTableIDI_GAIN_CURVERow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_GAIN_CURVERowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_GAIN_CURVERow));

  /* initialize values */
  out->name = g_strdup("TableIDI_GAIN_CURVE Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_GAIN_CURVERowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->type1 = iRow + table->type1Off;
    if (table->numPol>=1) out->nterm1 = iRow + table->nterm1Off;
    if (table->numPol>=1) out->x_typ1 = iRow + table->x_typ1Off;
    if (table->numPol>=1) out->y_typ1 = iRow + table->y_typ1Off;
    if (table->numPol>=1) out->x_val1 = fRow + table->x_val1Off;
    if (table->numPol>=1) out->y_val1 = fRow + table->y_val1Off;
    if (table->numPol>=1) out->gain1 = fRow + table->gain1Off;
    if (table->numPol>=1) out->sens1 = fRow + table->sens1Off;
    if (table->numPol>=2) out->type2 = iRow + table->type2Off;
    if (table->numPol>=2) out->nterm2 = iRow + table->nterm2Off;
    if (table->numPol>=2) out->x_typ2 = iRow + table->x_typ2Off;
    if (table->numPol>=2) out->y_typ2 = iRow + table->y_typ2Off;
    if (table->numPol>=2) out->x_val2 = fRow + table->x_val2Off;
    if (table->numPol>=2) out->y_val2 = fRow + table->y_val2Off;
    if (table->numPol>=2) out->gain2 = fRow + table->gain2Off;
    if (table->numPol>=2) out->sens2 = fRow + table->sens2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_GAIN_CURVERow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_GAIN_CURVERowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_GAIN_CURVERowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_GAIN_CURVERowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_GAIN_CURVE* newObitTableIDI_GAIN_CURVE (gchar* name)
{
  ObitTableIDI_GAIN_CURVE* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_GAIN_CURVEClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_GAIN_CURVE));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_GAIN_CURVEInit((gpointer)out);

 return out;
} /* end newObitTableIDI_GAIN_CURVE */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_GAIN_CURVEGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_GAIN_CURVEClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_GAIN_CURVEGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations
 * \param no_band Number of frequency bands
 * \param numTabs The number of tabulated terms
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_GAIN_CURVE* newObitTableIDI_GAIN_CURVEValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint no_band, oint numTabs,
		     ObitErr *err)
{
  ObitTableIDI_GAIN_CURVE* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "GAIN_CURVE";
  gchar *routine = "newObitTableIDI_GAIN_CURVEValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_GAIN_CURVEClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "GAIN_CURVE");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_GAIN_CURVE */
      if (ObitTableIDI_GAIN_CURVEIsA(testTab)) { /* it is an ObitTableIDI_GAIN_CURVE */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_GAIN_CURVEConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "GAIN_CURVE");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_GAIN_CURVEIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_GAIN_CURVEConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->no_band = MAX (0, no_band);
  out->numTabs = MAX (0, numTabs);
  out->tabrev = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->no_chan = 1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_GAIN_CURVE );
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_GAIN_CURVE );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 3 + out->numPol*8 + out->no_band*0 + out->numTabs*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("TYPE_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("NTERM_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("X_TYP_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("Y_TYP_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("X_VAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("Y_VAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("GAIN_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("SENS_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("TYPE_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("NTERM_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("X_TYP_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("Y_TYP_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("X_VAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("Y_VAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("GAIN_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("SENS_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_GAIN_CURVEDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_GAIN_CURVEOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_GAIN_CURVEClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_GAIN_CURVEValue */

/**
 * Convert an ObitTable to an ObitTableIDI_GAIN_CURVE.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_GAIN_CURVE* ObitTableIDI_GAIN_CURVEConvert (ObitTable* in)
{
  ObitTableIDI_GAIN_CURVE *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_GAIN_CURVE(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_GAIN_CURVEConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_GAIN_CURVE* ObitTableIDI_GAIN_CURVECopy (ObitTableIDI_GAIN_CURVE *in, ObitTableIDI_GAIN_CURVE *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_GAIN_CURVECopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_GAIN_CURVEClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_GAIN_CURVE*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->numPol = in->numPol;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_GAIN_CURVE );
  strncpy (out->ArrName, in->ArrName, MAXKEYCHARTABLEIDI_GAIN_CURVE );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEIDI_GAIN_CURVE );
  out->numTabs = in->numTabs;
  /* Update class specific info */
  ObitTableIDI_GAIN_CURVEUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_GAIN_CURVECopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_GAIN_CURVEOpen (ObitTableIDI_GAIN_CURVE *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_GAIN_CURVEOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_GAIN_CURVEClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_GAIN_CURVEUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_GAIN_CURVEOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_GAIN_CURVERow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_GAIN_CURVEReadRow  (ObitTableIDI_GAIN_CURVE *in, olong iIDI_GAIN_CURVERow, ObitTableIDI_GAIN_CURVERow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_GAIN_CURVEReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_GAIN_CURVE Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_GAIN_CURVERow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_GAIN_CURVERow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->antNo = iRow[in->antNoOff];
  row->Array = iRow[in->ArrayOff];
  row->fqid = iRow[in->fqidOff];
  if (in->numPol>=1) row->type1 = iRow + in->type1Off;
  if (in->numPol>=1) row->nterm1 = iRow + in->nterm1Off;
  if (in->numPol>=1) row->x_typ1 = iRow + in->x_typ1Off;
  if (in->numPol>=1) row->y_typ1 = iRow + in->y_typ1Off;
  if (in->numPol>=1) row->x_val1 = fRow + in->x_val1Off;
  if (in->numPol>=1) row->y_val1 = fRow + in->y_val1Off;
  if (in->numPol>=1) row->gain1 = fRow + in->gain1Off;
  if (in->numPol>=1) row->sens1 = fRow + in->sens1Off;
  if (in->numPol>=2) row->type2 = iRow + in->type2Off;
  if (in->numPol>=2) row->nterm2 = iRow + in->nterm2Off;
  if (in->numPol>=2) row->x_typ2 = iRow + in->x_typ2Off;
  if (in->numPol>=2) row->y_typ2 = iRow + in->y_typ2Off;
  if (in->numPol>=2) row->x_val2 = fRow + in->x_val2Off;
  if (in->numPol>=2) row->y_val2 = fRow + in->y_val2Off;
  if (in->numPol>=2) row->gain2 = fRow + in->gain2Off;
  if (in->numPol>=2) row->sens2 = fRow + in->sens2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_GAIN_CURVEReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_GAIN_CURVESetRow  (ObitTableIDI_GAIN_CURVE *in, ObitTableIDI_GAIN_CURVERow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_GAIN_CURVE Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->type1 = iRow + in->type1Off;
  if (in->numPol>=1) row->nterm1 = iRow + in->nterm1Off;
  if (in->numPol>=1) row->x_typ1 = iRow + in->x_typ1Off;
  if (in->numPol>=1) row->y_typ1 = iRow + in->y_typ1Off;
  if (in->numPol>=1) row->x_val1 = fRow + in->x_val1Off;
  if (in->numPol>=1) row->y_val1 = fRow + in->y_val1Off;
  if (in->numPol>=1) row->gain1 = fRow + in->gain1Off;
  if (in->numPol>=1) row->sens1 = fRow + in->sens1Off;
  if (in->numPol>=2) row->type2 = iRow + in->type2Off;
  if (in->numPol>=2) row->nterm2 = iRow + in->nterm2Off;
  if (in->numPol>=2) row->x_typ2 = iRow + in->x_typ2Off;
  if (in->numPol>=2) row->y_typ2 = iRow + in->y_typ2Off;
  if (in->numPol>=2) row->x_val2 = fRow + in->x_val2Off;
  if (in->numPol>=2) row->y_val2 = fRow + in->y_val2Off;
  if (in->numPol>=2) row->gain2 = fRow + in->gain2Off;
  if (in->numPol>=2) row->sens2 = fRow + in->sens2Off;

} /*  end ObitTableIDI_GAIN_CURVESetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_GAIN_CURVESetRow  
 * \param in       Table to read
 * \param iIDI_GAIN_CURVERow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_GAIN_CURVEWriteRow  (ObitTableIDI_GAIN_CURVE *in, olong iIDI_GAIN_CURVERow, ObitTableIDI_GAIN_CURVERow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_GAIN_CURVEWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_GAIN_CURVE Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->antNoOff] = row->antNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->fqidOff] = row->fqid;
  if (in->numPol>=1)
    if (in->type1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->type1Col]; i++) 
        iRow[in->type1Off+i] = row->type1[i];
    } 
  if (in->numPol>=1)
    if (in->nterm1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->nterm1Col]; i++) 
        iRow[in->nterm1Off+i] = row->nterm1[i];
    } 
  if (in->numPol>=1)
    if (in->x_typ1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->x_typ1Col]; i++) 
        iRow[in->x_typ1Off+i] = row->x_typ1[i];
    } 
  if (in->numPol>=1)
    if (in->y_typ1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->y_typ1Col]; i++) 
        iRow[in->y_typ1Off+i] = row->y_typ1[i];
    } 
  if (in->numPol>=1)
    if (in->x_val1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->x_val1Col]; i++) 
        fRow[in->x_val1Off+i] = row->x_val1[i];
    } 
  if (in->numPol>=1)
    if (in->y_val1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->y_val1Col]; i++) 
        fRow[in->y_val1Off+i] = row->y_val1[i];
    } 
  if (in->numPol>=1)
    if (in->gain1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->gain1Col]; i++) 
        fRow[in->gain1Off+i] = row->gain1[i];
    } 
  if (in->numPol>=1)
    if (in->sens1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sens1Col]; i++) 
        fRow[in->sens1Off+i] = row->sens1[i];
    } 
  if (in->numPol>=2)
    if (in->type2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->type2Col]; i++) 
        iRow[in->type2Off+i] = row->type2[i];
    } 
  if (in->numPol>=2)
    if (in->nterm2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->nterm2Col]; i++) 
        iRow[in->nterm2Off+i] = row->nterm2[i];
    } 
  if (in->numPol>=2)
    if (in->x_typ2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->x_typ2Col]; i++) 
        iRow[in->x_typ2Off+i] = row->x_typ2[i];
    } 
  if (in->numPol>=2)
    if (in->y_typ2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->y_typ2Col]; i++) 
        iRow[in->y_typ2Off+i] = row->y_typ2[i];
    } 
  if (in->numPol>=2)
    if (in->x_val2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->x_val2Col]; i++) 
        fRow[in->x_val2Off+i] = row->x_val2[i];
    } 
  if (in->numPol>=2)
    if (in->y_val2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->y_val2Col]; i++) 
        fRow[in->y_val2Off+i] = row->y_val2[i];
    } 
  if (in->numPol>=2)
    if (in->gain2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->gain2Col]; i++) 
        fRow[in->gain2Off+i] = row->gain2[i];
    } 
  if (in->numPol>=2)
    if (in->sens2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sens2Col]; i++) 
        fRow[in->sens2Off+i] = row->sens2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_GAIN_CURVERow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_GAIN_CURVERow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_GAIN_CURVEWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_GAIN_CURVEClose (ObitTableIDI_GAIN_CURVE *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_GAIN_CURVEClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_GAIN_CURVEDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_GAIN_CURVEClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_GAIN_CURVE Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_GAIN_CURVERowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_GAIN_CURVERow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->type1 = NULL;
  in->nterm1 = NULL;
  in->x_typ1 = NULL;
  in->y_typ1 = NULL;
  in->x_val1 = NULL;
  in->y_val1 = NULL;
  in->gain1 = NULL;
  in->sens1 = NULL;
  in->type2 = NULL;
  in->nterm2 = NULL;
  in->x_typ2 = NULL;
  in->y_typ2 = NULL;
  in->x_val2 = NULL;
  in->y_val2 = NULL;
  in->gain2 = NULL;
  in->sens2 = NULL;

} /* end ObitTableIDI_GAIN_CURVERowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_GAIN_CURVERow* cast to an Obit*.
 */
void ObitTableIDI_GAIN_CURVERowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_GAIN_CURVERow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_GAIN_CURVERowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_GAIN_CURVERowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_GAIN_CURVERowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_GAIN_CURVERowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_GAIN_CURVERowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_GAIN_CURVERowClassInfo *theClass = (ObitTableIDI_GAIN_CURVERowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_GAIN_CURVERowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_GAIN_CURVERowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_GAIN_CURVERowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_GAIN_CURVERow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_GAIN_CURVERowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_GAIN_CURVERowInit;

} /* end ObitTableIDI_GAIN_CURVERowClassDefFn */

/*------------------  TableIDI_GAIN_CURVE  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_GAIN_CURVEInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_GAIN_CURVE *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_GAIN_CURVEInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_GAIN_CURVE* cast to an Obit*.
 */
void ObitTableIDI_GAIN_CURVEClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_GAIN_CURVE *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_GAIN_CURVEClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_GAIN_CURVEClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_GAIN_CURVEClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_GAIN_CURVEClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_GAIN_CURVEClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_GAIN_CURVEClassInfo *theClass = (ObitTableIDI_GAIN_CURVEClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_GAIN_CURVEClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_GAIN_CURVEClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_GAIN_CURVEGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_GAIN_CURVE;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_GAIN_CURVECopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_GAIN_CURVEClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_GAIN_CURVEInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_GAIN_CURVEConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_GAIN_CURVEOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_GAIN_CURVEClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_GAIN_CURVEReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_GAIN_CURVEWriteRow;

} /* end ObitTableIDI_GAIN_CURVEClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_GAIN_CURVEUpdate (ObitTableIDI_GAIN_CURVE *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* numPol */
  if (!ObitInfoListGet(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol, err)) return;
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_GAIN_CURVE); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* ArrName */
  if (!ObitInfoListGet(in->myDesc->info, "ARRNAM", &type, dim, 
		       (gpointer)&in->ArrName, err)) return;
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_GAIN_CURVE); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numTabs */
  if (!ObitInfoListGet(in->myDesc->info, "NO_TABS", &type, dim, 
		       (gpointer)&in->numTabs, err)) return;

  /* initialize column numbers/offsets */
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->fqidOff = -1;
  in->fqidCol = -1;
  in->type1Off = -1;
  in->type1Col = -1;
  in->nterm1Off = -1;
  in->nterm1Col = -1;
  in->x_typ1Off = -1;
  in->x_typ1Col = -1;
  in->y_typ1Off = -1;
  in->y_typ1Col = -1;
  in->x_val1Off = -1;
  in->x_val1Col = -1;
  in->y_val1Off = -1;
  in->y_val1Col = -1;
  in->gain1Off = -1;
  in->gain1Col = -1;
  in->sens1Off = -1;
  in->sens1Col = -1;
  in->type2Off = -1;
  in->type2Col = -1;
  in->nterm2Off = -1;
  in->nterm2Col = -1;
  in->x_typ2Off = -1;
  in->x_typ2Col = -1;
  in->y_typ2Off = -1;
  in->y_typ2Col = -1;
  in->x_val2Off = -1;
  in->x_val2Col = -1;
  in->y_val2Off = -1;
  in->y_val2Col = -1;
  in->gain2Off = -1;
  in->gain2Col = -1;
  in->sens2Off = -1;
  in->sens2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY", 5)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->fqidOff = desc->offset[i];
 	 in->fqidCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TYPE_1", 6)) {
	     in->type1Off = desc->offset[i];
 	     in->type1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "NTERM_1", 7)) {
	     in->nterm1Off = desc->offset[i];
 	     in->nterm1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_TYP_1", 7)) {
	     in->x_typ1Off = desc->offset[i];
 	     in->x_typ1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_TYP_1", 7)) {
	     in->y_typ1Off = desc->offset[i];
 	     in->y_typ1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_VAL_1", 7)) {
	     in->x_val1Off = desc->offset[i];
 	     in->x_val1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_VAL_1", 7)) {
	     in->y_val1Off = desc->offset[i];
 	     in->y_val1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GAIN_1", 6)) {
	     in->gain1Off = desc->offset[i];
 	     in->gain1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENS_1", 6)) {
	     in->sens1Off = desc->offset[i];
 	     in->sens1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "TYPE_2", 6)) {
	     in->type2Off = desc->offset[i];
 	     in->type2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "NTERM_2", 7)) {
	     in->nterm2Off = desc->offset[i];
 	     in->nterm2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_TYP_2", 7)) {
	     in->x_typ2Off = desc->offset[i];
 	     in->x_typ2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_TYP_2", 7)) {
	     in->y_typ2Off = desc->offset[i];
 	     in->y_typ2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_VAL_2", 7)) {
	     in->x_val2Off = desc->offset[i];
 	     in->x_val2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_VAL_2", 7)) {
	     in->y_val2Off = desc->offset[i];
 	     in->y_val2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GAIN_2", 6)) {
	     in->gain2Off = desc->offset[i];
 	     in->gain2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENS_2", 6)) {
	     in->sens2Off = desc->offset[i];
 	     in->sens2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column antNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column Array");
  Obit_return_if_fail((in->fqidOff > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column fqid");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->type1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column type1");
    Obit_return_if_fail((in->nterm1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column nterm1");
    Obit_return_if_fail((in->x_typ1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column x_typ1");
    Obit_return_if_fail((in->y_typ1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column y_typ1");
    Obit_return_if_fail((in->x_val1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column x_val1");
    Obit_return_if_fail((in->y_val1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column y_val1");
    Obit_return_if_fail((in->gain1Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column gain1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->type2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column type2");
    Obit_return_if_fail((in->nterm2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column nterm2");
    Obit_return_if_fail((in->x_typ2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column x_typ2");
    Obit_return_if_fail((in->y_typ2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column y_typ2");
    Obit_return_if_fail((in->x_val2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column x_val2");
    Obit_return_if_fail((in->y_val2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column y_val2");
    Obit_return_if_fail((in->gain2Off > -1), err,
       "ObitTableIDI_GAIN_CURVEUpdate: Could not find column gain2");
  } /* end of if index in range */
} /* end ObitTableIDI_GAIN_CURVEUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_GAIN_CURVEDumpKey (ObitTableIDI_GAIN_CURVE *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_GAIN_CURVE;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* ArrName */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_GAIN_CURVE;
  ObitInfoListAlwaysPut(info, "ARRNAM", type, dim, 
		  (gpointer)&in->ArrName);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_GAIN_CURVE;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numTabs */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_TABS", type, dim, 
		  (gpointer)&in->numTabs);
   
} /* end ObitTableIDI_GAIN_CURVEDumpKey */
