/* $Id: ObitTableIDI_UV_DATA.c 190 2010-05-04 15:21:06Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2010                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_UV_DATA.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_UV_DATA.c
 * ObitTableIDI_UV_DATA class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_UV_DATA";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_UV_DATARow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_UV_DATARowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_UV_DATAClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_UV_DATAClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_UV_DATARowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_UV_DATARowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_UV_DATAInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_UV_DATAClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_UV_DATAUpdate (ObitTableIDI_UV_DATA *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_UV_DATADumpKey (ObitTableIDI_UV_DATA *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_UV_DATAClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_UV_DATARowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_UV_DATARow* newObitTableIDI_UV_DATARow (ObitTableIDI_UV_DATA *table)
{
  ObitTableIDI_UV_DATARow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_UV_DATARowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_UV_DATARow));

  /* initialize values */
  out->name = g_strdup("TableIDI_UV_DATA Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_UV_DATARowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->Weight = fRow + table->WeightOff;
    out->Flux = fRow + table->FluxOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_UV_DATARow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_UV_DATARowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_UV_DATARowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_UV_DATARowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_UV_DATA* newObitTableIDI_UV_DATA (gchar* name)
{
  ObitTableIDI_UV_DATA* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_UV_DATAClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_UV_DATA));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_UV_DATAInit((gpointer)out);

 return out;
} /* end newObitTableIDI_UV_DATA */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_UV_DATAGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_UV_DATAClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_UV_DATAGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param no_band Number of frequency bands (IF)
 * \param maxis1 [OPTIONAL] Number of pixels on axis 1
 * \param maxis2 [OPTIONAL] Number of pixels on axis 2
 * \param maxis3 [OPTIONAL] Number of pixels on axis 3
 * \param maxis4 [OPTIONAL] Number of pixels on axis 4
 * \param maxis5 [OPTIONAL] Number of pixels on axis 5
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_UV_DATA* newObitTableIDI_UV_DATAValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint no_band, oint maxis1, oint maxis2, oint maxis3, oint maxis4, oint maxis5,
		     ObitErr *err)
{
  ObitTableIDI_UV_DATA* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "UV_DATA";
  gchar *routine = "newObitTableIDI_UV_DATAValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_UV_DATAClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "UV_DATA");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_UV_DATA */
      if (ObitTableIDI_UV_DATAIsA(testTab)) { /* it is an ObitTableIDI_UV_DATA */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_UV_DATAConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "UV_DATA");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_UV_DATAIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_UV_DATAConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->no_band = MAX (0, no_band);
  out->maxis1 = MAX (0, maxis1);
  out->maxis2 = MAX (0, maxis2);
  out->maxis3 = MAX (0, maxis3);
  out->maxis4 = MAX (0, maxis4);
  out->maxis5 = MAX (0, maxis5);
  out->tabrev = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->no_chan = 1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_UV_DATA );
  out->nmatrix = 1;
  out->maxis = 1;
  strncpy (out->Equinox, "J2000   ", MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->WeighTyp, "NORMAL", MAXKEYCHARTABLEIDI_UV_DATA );
  out->tmatx01 = FALSE;
  out->tmatx02 = FALSE;
  out->tmatx03 = FALSE;
  out->tmatx04 = FALSE;
  out->tmatx05 = FALSE;
  out->tmatx06 = FALSE;
  out->tmatx07 = FALSE;
  out->tmatx08 = FALSE;
  out->tmatx09 = FALSE;
  out->tmatx10 = FALSE;
  out->tmatx11 = FALSE;
  out->tmatx12 = FALSE;
  out->tmatx13 = FALSE;
  out->tmatx14 = FALSE;
  out->tmatx15 = FALSE;
  strncpy (out->ctype1, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt1 = 0.0;
  out->crpix1 = 1.0;
  out->crval1 = 0.0;
  strncpy (out->ctype2, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt2 = 0.0;
  out->crpix2 = 1.0;
  out->crval2 = 0.0;
  strncpy (out->ctype3, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt3 = 0.0;
  out->crpix3 = 1.0;
  out->crval3 = 0.0;
  strncpy (out->ctype4, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt4 = 0.0;
  out->crpix4 = 1.0;
  out->crval4 = 0.0;
  strncpy (out->ctype5, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt5 = 0.0;
  out->crpix5 = 1.0;
  out->crval5 = 0.0;
  out->maxis6 = 1;
  strncpy (out->ctype6, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt6 = 0.0;
  out->crpix6 = 1.0;
  out->crval6 = 0.0;
  out->maxis7 = 1;
  strncpy (out->ctype7, "    ", MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt7 = 0.0;
  out->crpix7 = 1.0;
  out->crval7 = 0.0;
  strncpy (out->dateObs, "0000-00-00", MAXKEYCHARTABLEIDI_UV_DATA );
  out->visScale = 1.0;
  strncpy (out->sort, "  ", MAXKEYCHARTABLEIDI_UV_DATA );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 14 + out->no_band*0 + out->maxis1*0 + out->maxis2*0 + out->maxis3*0 + out->maxis4*0 + out->maxis5*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("UU      ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("VV      ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("WW      ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DATE    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("BASELINE");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FILTER  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("INTTIM");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((maxis2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("WEIGHT");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = maxis2;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("GATEID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((maxis1 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FLUX    ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = maxis1;
    desc->dim[colNo][1] = maxis2;
    desc->dim[colNo][2] = maxis3;
    desc->dim[colNo][3] = maxis4;
    desc->dim[colNo][4] = maxis4;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_UV_DATADumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_UV_DATAOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_UV_DATAClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_UV_DATAValue */

/**
 * Convert an ObitTable to an ObitTableIDI_UV_DATA.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_UV_DATA* ObitTableIDI_UV_DATAConvert (ObitTable* in)
{
  ObitTableIDI_UV_DATA *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_UV_DATA(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_UV_DATAConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_UV_DATA* ObitTableIDI_UV_DATACopy (ObitTableIDI_UV_DATA *in, ObitTableIDI_UV_DATA *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_UV_DATACopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_UV_DATAClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_UV_DATA*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEIDI_UV_DATA );
  out->nmatrix = in->nmatrix;
  out->maxis = in->maxis;
  strncpy (out->Equinox, in->Equinox, MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->WeighTyp, in->WeighTyp, MAXKEYCHARTABLEIDI_UV_DATA );
  out->tmatx01 = in->tmatx01;
  out->tmatx02 = in->tmatx02;
  out->tmatx03 = in->tmatx03;
  out->tmatx04 = in->tmatx04;
  out->tmatx05 = in->tmatx05;
  out->tmatx06 = in->tmatx06;
  out->tmatx07 = in->tmatx07;
  out->tmatx08 = in->tmatx08;
  out->tmatx09 = in->tmatx09;
  out->tmatx10 = in->tmatx10;
  out->tmatx11 = in->tmatx11;
  out->tmatx12 = in->tmatx12;
  out->tmatx13 = in->tmatx13;
  out->tmatx14 = in->tmatx14;
  out->tmatx15 = in->tmatx15;
  out->maxis1 = in->maxis1;
  strncpy (out->ctype1, in->ctype1, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt1 = in->cdelt1;
  out->crpix1 = in->crpix1;
  out->crval1 = in->crval1;
  out->maxis2 = in->maxis2;
  strncpy (out->ctype2, in->ctype2, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt2 = in->cdelt2;
  out->crpix2 = in->crpix2;
  out->crval2 = in->crval2;
  out->maxis3 = in->maxis3;
  strncpy (out->ctype3, in->ctype3, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt3 = in->cdelt3;
  out->crpix3 = in->crpix3;
  out->crval3 = in->crval3;
  out->maxis4 = in->maxis4;
  strncpy (out->ctype4, in->ctype4, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt4 = in->cdelt4;
  out->crpix4 = in->crpix4;
  out->crval4 = in->crval4;
  out->maxis5 = in->maxis5;
  strncpy (out->ctype5, in->ctype5, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt5 = in->cdelt5;
  out->crpix5 = in->crpix5;
  out->crval5 = in->crval5;
  out->maxis6 = in->maxis6;
  strncpy (out->ctype6, in->ctype6, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt6 = in->cdelt6;
  out->crpix6 = in->crpix6;
  out->crval6 = in->crval6;
  out->maxis7 = in->maxis7;
  strncpy (out->ctype7, in->ctype7, MAXKEYCHARTABLEIDI_UV_DATA );
  out->cdelt7 = in->cdelt7;
  out->crpix7 = in->crpix7;
  out->crval7 = in->crval7;
  strncpy (out->dateObs, in->dateObs, MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->teles, in->teles, MAXKEYCHARTABLEIDI_UV_DATA );
  strncpy (out->observer, in->observer, MAXKEYCHARTABLEIDI_UV_DATA );
  out->visScale = in->visScale;
  strncpy (out->sort, in->sort, MAXKEYCHARTABLEIDI_UV_DATA );
  /* Update class specific info */
  ObitTableIDI_UV_DATAUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_UV_DATACopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_UV_DATAOpen (ObitTableIDI_UV_DATA *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_UV_DATAOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_UV_DATAClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_UV_DATAUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_UV_DATAOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_UV_DATARow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_UV_DATAReadRow  (ObitTableIDI_UV_DATA *in, olong iIDI_UV_DATARow, ObitTableIDI_UV_DATARow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_UV_DATAReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_UV_DATA Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_UV_DATARow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_UV_DATARow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->uu = fRow[in->uuOff];
  row->vv = fRow[in->vvOff];
  row->ww = fRow[in->wwOff];
  row->date = dRow[in->dateOff];
  row->Time = dRow[in->TimeOff];
  row->Baseline = iRow[in->BaselineOff];
  row->Array = iRow[in->ArrayOff];
  row->Filter = iRow[in->FilterOff];
  row->Source = iRow[in->SourceOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->IntTim = fRow[in->IntTimOff];
  row->GateID = iRow[in->GateIDOff];
  row->Weight = fRow + in->WeightOff;
  row->Flux = fRow + in->FluxOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_UV_DATAReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_UV_DATASetRow  (ObitTableIDI_UV_DATA *in, ObitTableIDI_UV_DATARow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_UV_DATA Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->Weight = fRow + in->WeightOff;
  row->Flux = fRow + in->FluxOff;

} /*  end ObitTableIDI_UV_DATASetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_UV_DATASetRow  
 * \param in       Table to read
 * \param iIDI_UV_DATARow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_UV_DATAWriteRow  (ObitTableIDI_UV_DATA *in, olong iIDI_UV_DATARow, ObitTableIDI_UV_DATARow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_UV_DATAWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_UV_DATA Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  fRow[in->uuOff] = row->uu;
  fRow[in->vvOff] = row->vv;
  fRow[in->wwOff] = row->ww;
  dRow[in->dateOff] = row->date;
  dRow[in->TimeOff] = row->Time;
  iRow[in->BaselineOff] = row->Baseline;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->FilterOff] = row->Filter;
  iRow[in->SourceOff] = row->Source;
  iRow[in->FreqIDOff] = row->FreqID;
  fRow[in->IntTimOff] = row->IntTim;
  iRow[in->GateIDOff] = row->GateID;
  if (in->WeightCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->WeightCol]; i++) 
      fRow[in->WeightOff+i] = row->Weight[i];
  } 
  if (in->FluxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FluxCol]; i++) 
      fRow[in->FluxOff+i] = row->Flux[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_UV_DATARow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_UV_DATARow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_UV_DATAWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_UV_DATAClose (ObitTableIDI_UV_DATA *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_UV_DATAClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_UV_DATADumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_UV_DATAClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_UV_DATA Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_UV_DATARowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_UV_DATARow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->Weight = NULL;
  in->Flux = NULL;

} /* end ObitTableIDI_UV_DATARowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_UV_DATARow* cast to an Obit*.
 */
void ObitTableIDI_UV_DATARowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_UV_DATARow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_UV_DATARowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_UV_DATARowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_UV_DATARowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_UV_DATARowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_UV_DATARowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_UV_DATARowClassInfo *theClass = (ObitTableIDI_UV_DATARowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_UV_DATARowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_UV_DATARowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_UV_DATARowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_UV_DATARow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_UV_DATARowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_UV_DATARowInit;

} /* end ObitTableIDI_UV_DATARowClassDefFn */

/*------------------  TableIDI_UV_DATA  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_UV_DATAInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_UV_DATA *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_UV_DATAInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_UV_DATA* cast to an Obit*.
 */
void ObitTableIDI_UV_DATAClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_UV_DATA *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_UV_DATAClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_UV_DATAClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_UV_DATAClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_UV_DATAClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_UV_DATAClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_UV_DATAClassInfo *theClass = (ObitTableIDI_UV_DATAClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_UV_DATAClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_UV_DATAClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_UV_DATAGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_UV_DATA;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_UV_DATACopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_UV_DATAClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_UV_DATAInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_UV_DATAConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_UV_DATAOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_UV_DATAClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_UV_DATAReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_UV_DATAWriteRow;

} /* end ObitTableIDI_UV_DATAClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_UV_DATAUpdate (ObitTableIDI_UV_DATA *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* nmatrix */
  in->nmatrix = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NMATRIX", &type, dim, 
		       (gpointer)&in->nmatrix);
   /* maxis */
  in->maxis = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS", &type, dim, 
		       (gpointer)&in->maxis);
   /* Equinox */
  strncpy (in->Equinox, "J2000   ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "EQUINOX", &type, dim, 
		       (gpointer)&in->Equinox);
   /* WeighTyp */
  strncpy (in->WeighTyp, "NORMAL", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "WEIGHTYP", &type, dim, 
		       (gpointer)&in->WeighTyp);
   /* tmatx01 */
  in->tmatx01 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX01", &type, dim, 
		       (gpointer)&in->tmatx01);
   /* tmatx02 */
  in->tmatx02 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX02", &type, dim, 
		       (gpointer)&in->tmatx02);
   /* tmatx03 */
  in->tmatx03 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX03", &type, dim, 
		       (gpointer)&in->tmatx03);
   /* tmatx04 */
  in->tmatx04 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX04", &type, dim, 
		       (gpointer)&in->tmatx04);
   /* tmatx05 */
  in->tmatx05 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX05", &type, dim, 
		       (gpointer)&in->tmatx05);
   /* tmatx06 */
  in->tmatx06 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX06", &type, dim, 
		       (gpointer)&in->tmatx06);
   /* tmatx07 */
  in->tmatx07 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX07", &type, dim, 
		       (gpointer)&in->tmatx07);
   /* tmatx08 */
  in->tmatx08 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX08", &type, dim, 
		       (gpointer)&in->tmatx08);
   /* tmatx09 */
  in->tmatx09 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX09", &type, dim, 
		       (gpointer)&in->tmatx09);
   /* tmatx10 */
  in->tmatx10 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX10", &type, dim, 
		       (gpointer)&in->tmatx10);
   /* tmatx11 */
  in->tmatx11 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX11", &type, dim, 
		       (gpointer)&in->tmatx11);
   /* tmatx12 */
  in->tmatx12 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX12", &type, dim, 
		       (gpointer)&in->tmatx12);
   /* tmatx13 */
  in->tmatx13 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX13", &type, dim, 
		       (gpointer)&in->tmatx13);
   /* tmatx14 */
  in->tmatx14 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX14", &type, dim, 
		       (gpointer)&in->tmatx14);
   /* tmatx15 */
  in->tmatx15 = FALSE; 
  ObitInfoListGetTest(in->myDesc->info, "TMATX15", &type, dim, 
		       (gpointer)&in->tmatx15);
   /* maxis1 */
  in->maxis1 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS1", &type, dim, 
		       (gpointer)&in->maxis1);
   /* ctype1 */
  strncpy (in->ctype1, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE1", &type, dim, 
		       (gpointer)&in->ctype1);
  in->cdelt1 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT1", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt1 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt1 = InfoReal.flt;
  in->crpix1 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX1", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix1 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix1 = InfoReal.flt;
  in->crval1 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL1", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval1 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval1 = InfoReal.flt;
   /* maxis2 */
  in->maxis2 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS2", &type, dim, 
		       (gpointer)&in->maxis2);
   /* ctype2 */
  strncpy (in->ctype2, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE2", &type, dim, 
		       (gpointer)&in->ctype2);
  in->cdelt2 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT2", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt2 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt2 = InfoReal.flt;
  in->crpix2 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX2", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix2 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix2 = InfoReal.flt;
  in->crval2 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL2", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval2 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval2 = InfoReal.flt;
   /* maxis3 */
  in->maxis3 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS3", &type, dim, 
		       (gpointer)&in->maxis3);
   /* ctype3 */
  strncpy (in->ctype3, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE3", &type, dim, 
		       (gpointer)&in->ctype3);
  in->cdelt3 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT3", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt3 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt3 = InfoReal.flt;
  in->crpix3 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX3", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix3 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix3 = InfoReal.flt;
  in->crval3 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL3", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval3 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval3 = InfoReal.flt;
   /* maxis4 */
  in->maxis4 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS4", &type, dim, 
		       (gpointer)&in->maxis4);
   /* ctype4 */
  strncpy (in->ctype4, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE4", &type, dim, 
		       (gpointer)&in->ctype4);
  in->cdelt4 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT4", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt4 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt4 = InfoReal.flt;
  in->crpix4 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX4", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix4 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix4 = InfoReal.flt;
  in->crval4 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL4", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval4 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval4 = InfoReal.flt;
   /* maxis5 */
  in->maxis5 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS5", &type, dim, 
		       (gpointer)&in->maxis5);
   /* ctype5 */
  strncpy (in->ctype5, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE5", &type, dim, 
		       (gpointer)&in->ctype5);
  in->cdelt5 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT5", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt5 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt5 = InfoReal.flt;
  in->crpix5 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX5", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix5 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix5 = InfoReal.flt;
  in->crval5 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL5", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval5 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval5 = InfoReal.flt;
   /* maxis6 */
  in->maxis6 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS6", &type, dim, 
		       (gpointer)&in->maxis6);
   /* ctype6 */
  strncpy (in->ctype6, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE6", &type, dim, 
		       (gpointer)&in->ctype6);
  in->cdelt6 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT6", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt6 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt6 = InfoReal.flt;
  in->crpix6 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX6", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix6 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix6 = InfoReal.flt;
  in->crval6 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL6", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval6 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval6 = InfoReal.flt;
   /* maxis7 */
  in->maxis7 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "MAXIS7", &type, dim, 
		       (gpointer)&in->maxis7);
   /* ctype7 */
  strncpy (in->ctype7, "    ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "CTYPE7", &type, dim, 
		       (gpointer)&in->ctype7);
  in->cdelt7 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CDELT7", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->cdelt7 = InfoReal.dbl;
  if (type==OBIT_float)  in->cdelt7 = InfoReal.flt;
  in->crpix7 = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRPIX7", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crpix7 = InfoReal.dbl;
  if (type==OBIT_float)  in->crpix7 = InfoReal.flt;
  in->crval7 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CRVAL7", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->crval7 = InfoReal.dbl;
  if (type==OBIT_float)  in->crval7 = InfoReal.flt;
   /* dateObs */
  strncpy (in->dateObs, "0000-00-00", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "DATE-OBS", &type, dim, 
		       (gpointer)&in->dateObs);
   /* teles */
  if (!ObitInfoListGet(in->myDesc->info, "TELESCOP", &type, dim, 
		       (gpointer)&in->teles, err)) return;
   /* observer */
  if (!ObitInfoListGet(in->myDesc->info, "OBSERVER", &type, dim, 
		       (gpointer)&in->observer, err)) return;
  in->visScale = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "VIS_SCAL", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->visScale = InfoReal.dbl;
  if (type==OBIT_float)  in->visScale = InfoReal.flt;
   /* sort */
  strncpy (in->sort, "  ", MAXKEYCHARTABLEIDI_UV_DATA); 
  ObitInfoListGetTest(in->myDesc->info, "SORT", &type, dim, 
		       (gpointer)&in->sort);

  /* initialize column numbers/offsets */
  in->uuOff = -1;
  in->uuCol = -1;
  in->vvOff = -1;
  in->vvCol = -1;
  in->wwOff = -1;
  in->wwCol = -1;
  in->dateOff = -1;
  in->dateCol = -1;
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->BaselineOff = -1;
  in->BaselineCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->FilterOff = -1;
  in->FilterCol = -1;
  in->SourceOff = -1;
  in->SourceCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->IntTimOff = -1;
  in->IntTimCol = -1;
  in->WeightOff = -1;
  in->WeightCol = -1;
  in->GateIDOff = -1;
  in->GateIDCol = -1;
  in->FluxOff = -1;
  in->FluxCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "UU      ", 8)) {
	 in->uuOff = desc->offset[i];
 	 in->uuCol = i;
      }
      if (!strncmp (desc->FieldName[i], "VV      ", 8)) {
	 in->vvOff = desc->offset[i];
 	 in->vvCol = i;
      }
      if (!strncmp (desc->FieldName[i], "WW      ", 8)) {
	 in->wwOff = desc->offset[i];
 	 in->wwCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DATE    ", 8)) {
	 in->dateOff = desc->offset[i];
 	 in->dateCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BASELINE", 8)) {
	 in->BaselineOff = desc->offset[i];
 	 in->BaselineCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY   ", 8)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FILTER  ", 8)) {
	 in->FilterOff = desc->offset[i];
 	 in->FilterCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID", 9)) {
	 in->SourceOff = desc->offset[i];
 	 in->SourceCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "INTTIM", 6)) {
	 in->IntTimOff = desc->offset[i];
 	 in->IntTimCol = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT", 6)) {
	 in->WeightOff = desc->offset[i];
 	 in->WeightCol = i;
      }
      if (!strncmp (desc->FieldName[i], "GATEID  ", 8)) {
	 in->GateIDOff = desc->offset[i];
 	 in->GateIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FLUX    ", 8)) {
	 in->FluxOff = desc->offset[i];
 	 in->FluxCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->uuOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column uu");
  Obit_return_if_fail((in->vvOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column vv");
  Obit_return_if_fail((in->wwOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column ww");
  Obit_return_if_fail((in->dateOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column date");
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column Time");
  Obit_return_if_fail((in->BaselineOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column Baseline");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column Array");
  Obit_return_if_fail((in->WeightOff > -1), err,
       "ObitTableIDI_UV_DATAUpdate: Could not find column Weight");
} /* end ObitTableIDI_UV_DATAUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_UV_DATADumpKey (ObitTableIDI_UV_DATA *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* nmatrix */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NMATRIX", type, dim, 
		  (gpointer)&in->nmatrix);
  /* maxis */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS", type, dim, 
		  (gpointer)&in->maxis);
  /* Equinox */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "EQUINOX", type, dim, 
		  (gpointer)&in->Equinox);
  /* WeighTyp */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "WEIGHTYP", type, dim, 
		  (gpointer)&in->WeighTyp);
  /* tmatx01 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX01", type, dim, 
		  (gpointer)&in->tmatx01);
  /* tmatx02 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX02", type, dim, 
		  (gpointer)&in->tmatx02);
  /* tmatx03 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX03", type, dim, 
		  (gpointer)&in->tmatx03);
  /* tmatx04 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX04", type, dim, 
		  (gpointer)&in->tmatx04);
  /* tmatx05 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX05", type, dim, 
		  (gpointer)&in->tmatx05);
  /* tmatx06 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX06", type, dim, 
		  (gpointer)&in->tmatx06);
  /* tmatx07 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX07", type, dim, 
		  (gpointer)&in->tmatx07);
  /* tmatx08 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX08", type, dim, 
		  (gpointer)&in->tmatx08);
  /* tmatx09 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX09", type, dim, 
		  (gpointer)&in->tmatx09);
  /* tmatx10 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX10", type, dim, 
		  (gpointer)&in->tmatx10);
  /* tmatx11 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX11", type, dim, 
		  (gpointer)&in->tmatx11);
  /* tmatx12 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX12", type, dim, 
		  (gpointer)&in->tmatx12);
  /* tmatx13 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX13", type, dim, 
		  (gpointer)&in->tmatx13);
  /* tmatx14 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX14", type, dim, 
		  (gpointer)&in->tmatx14);
  /* tmatx15 */
  type  = OBIT_bool;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TMATX15", type, dim, 
		  (gpointer)&in->tmatx15);
  /* maxis1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS1", type, dim, 
		  (gpointer)&in->maxis1);
  /* ctype1 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE1", type, dim, 
		  (gpointer)&in->ctype1);
  /* cdelt1 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT1", type, dim, 
		  (gpointer)&in->cdelt1);
  /* crpix1 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX1", type, dim, 
		  (gpointer)&in->crpix1);
  /* crval1 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL1", type, dim, 
		  (gpointer)&in->crval1);
  /* maxis2 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS2", type, dim, 
		  (gpointer)&in->maxis2);
  /* ctype2 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE2", type, dim, 
		  (gpointer)&in->ctype2);
  /* cdelt2 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT2", type, dim, 
		  (gpointer)&in->cdelt2);
  /* crpix2 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX2", type, dim, 
		  (gpointer)&in->crpix2);
  /* crval2 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL2", type, dim, 
		  (gpointer)&in->crval2);
  /* maxis3 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS3", type, dim, 
		  (gpointer)&in->maxis3);
  /* ctype3 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE3", type, dim, 
		  (gpointer)&in->ctype3);
  /* cdelt3 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT3", type, dim, 
		  (gpointer)&in->cdelt3);
  /* crpix3 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX3", type, dim, 
		  (gpointer)&in->crpix3);
  /* crval3 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL3", type, dim, 
		  (gpointer)&in->crval3);
  /* maxis4 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS4", type, dim, 
		  (gpointer)&in->maxis4);
  /* ctype4 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE4", type, dim, 
		  (gpointer)&in->ctype4);
  /* cdelt4 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT4", type, dim, 
		  (gpointer)&in->cdelt4);
  /* crpix4 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX4", type, dim, 
		  (gpointer)&in->crpix4);
  /* crval4 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL4", type, dim, 
		  (gpointer)&in->crval4);
  /* maxis5 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS5", type, dim, 
		  (gpointer)&in->maxis5);
  /* ctype5 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE5", type, dim, 
		  (gpointer)&in->ctype5);
  /* cdelt5 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT5", type, dim, 
		  (gpointer)&in->cdelt5);
  /* crpix5 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX5", type, dim, 
		  (gpointer)&in->crpix5);
  /* crval5 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL5", type, dim, 
		  (gpointer)&in->crval5);
  /* maxis6 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS6", type, dim, 
		  (gpointer)&in->maxis6);
  /* ctype6 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE6", type, dim, 
		  (gpointer)&in->ctype6);
  /* cdelt6 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT6", type, dim, 
		  (gpointer)&in->cdelt6);
  /* crpix6 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX6", type, dim, 
		  (gpointer)&in->crpix6);
  /* crval6 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL6", type, dim, 
		  (gpointer)&in->crval6);
  /* maxis7 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MAXIS7", type, dim, 
		  (gpointer)&in->maxis7);
  /* ctype7 */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "CTYPE7", type, dim, 
		  (gpointer)&in->ctype7);
  /* cdelt7 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CDELT7", type, dim, 
		  (gpointer)&in->cdelt7);
  /* crpix7 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRPIX7", type, dim, 
		  (gpointer)&in->crpix7);
  /* crval7 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CRVAL7", type, dim, 
		  (gpointer)&in->crval7);
  /* dateObs */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "DATE-OBS", type, dim, 
		  (gpointer)&in->dateObs);
  /* teles */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "TELESCOP", type, dim, 
		  (gpointer)&in->teles);
  /* observer */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "OBSERVER", type, dim, 
		  (gpointer)&in->observer);
  /* visScale */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "VIS_SCAL", type, dim, 
		  (gpointer)&in->visScale);
  /* sort */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_UV_DATA;
  ObitInfoListAlwaysPut(info, "SORT", type, dim, 
		  (gpointer)&in->sort);
   
} /* end ObitTableIDI_UV_DATADumpKey */
